# Smart Contracts - v1

VirtuSwap Smart Contracts implement the core functionality of the VirtuSwap protocol. The contracts are divided into Core contracts and Governance contracts.

The Core contracts define the logic of creation of the pool, providing liquidity, performing swaps on real and virtual pools, and exchange of reserves.

The Governance contracts define functionality related to protocol governance and distribution of VRSW rewards

The sections below describe each contract.

### Core

* [vPair](/virtuswap-documentation/technical-reference/smart-contracts-v1/dex-contracts/vpair.md)
* [vPairFactory](/virtuswap-documentation/technical-reference/smart-contracts-v1/dex-contracts/vpairfactory.md)
* [vRouter](/virtuswap-documentation/technical-reference/smart-contracts-v1/dex-contracts/vrouter-1.3.md)
* [vExchangeReserves](/virtuswap-documentation/technical-reference/smart-contracts-v1/dex-contracts/vexchangereserves.md)
* [Multicall](/virtuswap-documentation/technical-reference/smart-contracts-v1/dex-contracts/multicall.md)
* [Structures](/virtuswap-documentation/technical-reference/smart-contracts-v1/dex-contracts/structures.md)

### Tokenomics

* [VGlobalMinter](/virtuswap-documentation/technical-reference/smart-contracts-v1/tokenomics-contracts/vglobalminter.md)
* [VChainMinter](/virtuswap-documentation/technical-reference/smart-contracts-v1/tokenomics-contracts/vchainminter.md)
* [VStaker](/virtuswap-documentation/technical-reference/smart-contracts-v1/tokenomics-contracts/vstaker.md)
* [VTokenomicsParams](/virtuswap-documentation/technical-reference/smart-contracts-v1/tokenomics-contracts/vtokenomicsparams.md)
* [VVestingWallet](/virtuswap-documentation/technical-reference/smart-contracts-v1/tokenomics-contracts/vvestingwallet.md)

### Governance

* TBD


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.virtuswap.io/virtuswap-documentation/technical-reference/smart-contracts-v1.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
